diff -u -r old/asterisk-1.4.15/cdr/cdr_odbc.c asterisk-1.4.15/cdr/cdr_odbc.c
--- old/asterisk-1.4.15/cdr/cdr_odbc.c	2007-06-18 12:35:02.000000000 -0400
+++ asterisk-1.4.15/cdr/cdr_odbc.c	2008-01-11 12:38:40.000000000 -0500
@@ -423,7 +423,8 @@
 			connected = 0;
 			return -1;
 		}
-		SQLSetConnectAttr(ODBC_con, SQL_LOGIN_TIMEOUT, (SQLPOINTER *)10, 0);	
+		SQLSetConnectAttr(ODBC_con, SQL_ATTR_LOGIN_TIMEOUT, (SQLPOINTER *) 10, SQL_IS_UINTEGER);
+		SQLSetConnectAttr(ODBC_con, SQL_ATTR_CONNECTION_TIMEOUT, (SQLPOINTER *) 10, SQL_IS_UINTEGER);
 	}
 
 	/* Note that the username and password could be NULL here, but that is allowed in ODBC.
diff -u -r old/asterisk-1.4.15/res/res_config_odbc.c asterisk-1.4.15/res/res_config_odbc.c
--- old/asterisk-1.4.15/res/res_config_odbc.c	2007-11-25 12:17:10.000000000 -0500
+++ asterisk-1.4.15/res/res_config_odbc.c	2008-01-11 12:46:58.000000000 -0500
@@ -76,6 +76,7 @@
 		return NULL;
 	}
 
+	SQLSetStmtAttr(stmt, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 	res = SQLPrepare(stmt, (unsigned char *)cps->sql, SQL_NTS);
 	if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) {
 		ast_log(LOG_WARNING, "SQL Prepare failed![%s]\n", cps->sql);
@@ -432,6 +433,7 @@
 		return NULL;
 	}
 
+	SQLSetStmtAttr(sth, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 	res = SQLPrepare(sth, (unsigned char *)q->sql, SQL_NTS);
 	if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) {
 		if (option_verbose > 3)
diff -u -r old/asterisk-1.4.15/res/res_odbc.c asterisk-1.4.15/res/res_odbc.c
--- old/asterisk-1.4.15/res/res_odbc.c	2007-11-25 12:17:10.000000000 -0500
+++ asterisk-1.4.15/res/res_odbc.c	2008-01-11 14:32:28.000000000 -0500
@@ -94,6 +94,7 @@
 		stmt = prepare_cb(obj, data);
 
 		if (stmt) {
+			SQLSetStmtAttr(stmt, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 			res = SQLExecute(stmt);
 			if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO) && (res != SQL_NO_DATA)) {
 				if (res == SQL_ERROR) {
@@ -140,6 +141,7 @@
 	SQLSMALLINT diagbytes=0;
 	unsigned char state[10], diagnostic[256];
 
+	SQLSetStmtAttr(stmt, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 	res = SQLExecute(stmt);
 	if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO) && (res != SQL_NO_DATA)) {
 		if (res == SQL_ERROR) {
@@ -167,6 +169,7 @@
 		ast_mutex_unlock(&obj->lock);
 		odbc_obj_disconnect(obj);
 		odbc_obj_connect(obj);
+		SQLSetStmtAttr(stmt, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 		res = SQLExecute(stmt);
 #endif
 	}
@@ -186,6 +189,7 @@
 		if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) {
 			obj->up = 0;
 		} else {
+			SQLSetStmtAttr(stmt, SQL_ATTR_QUERY_TIMEOUT, (SQLPOINTER)10, SQL_IS_UINTEGER );
 			res = SQLPrepare(stmt, (unsigned char *)test_sql, SQL_NTS);
 			if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) {
 				obj->up = 0;
@@ -506,7 +510,8 @@
 		ast_mutex_unlock(&obj->lock);
 		return ODBC_FAIL;
 	}
-	SQLSetConnectAttr(obj->con, SQL_LOGIN_TIMEOUT, (SQLPOINTER *) 10, 0);
+	SQLSetConnectAttr(obj->con, SQL_ATTR_LOGIN_TIMEOUT, (SQLPOINTER *) 10, SQL_IS_UINTEGER);
+	SQLSetConnectAttr(obj->con, SQL_ATTR_CONNECTION_TIMEOUT, (SQLPOINTER *) 10, SQL_IS_UINTEGER);
 #ifdef NEEDTRACE
 	SQLSetConnectAttr(obj->con, SQL_ATTR_TRACE, &enable, SQL_IS_INTEGER);
 	SQLSetConnectAttr(obj->con, SQL_ATTR_TRACEFILE, tracefile, strlen(tracefile));
